/*
** TleenX3 (Tlen.pl Client)
** Copyright (c) 2004 Hubert Sokoowski <who_ami@tlen.pl>
**                    Pawe Biliski <rael@fr.pl>
**
** This code is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
**
*/


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <libtlen2/libtlen2.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"


#include "main.h"
#include "tlen.h"
#include "window-chat.h"
#include "window-login.h"
#include "window-misc.h"
#include "window-tuba.h"
#include "window-p2p.h"

gboolean on_window_main_delete_event (GtkWidget *window)
{
  profile_exit (USER_STATE_QUIT);
  return TRUE;
}


void
on_button_chat_send_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{

  window_chat_button_send_clicked ((GtkWidget*) button);

}


gboolean
on_window_login_delete_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  window_login_close ();

  return TRUE;
}


gboolean
on_window_login_destroy_event          (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  window_login_close ();

  return TRUE;
}


void
on_button_profiles_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  window_login_button_profiles_clicked ();
}


void
on_button_open_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  window_login_button_open_clicked ();

}


void
on_button_quit_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  window_login_close ();

}


gboolean
on_window_profiles_delete_event        (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  window_profiles_close ();
  return TRUE;
}


void
on_button_profiles_new_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  window_profiles_button_new_clicked ();

}


void
on_button_profiles_delete_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
  window_profiles_button_delete_clicked ();

}


void
on_button_profiles_edit_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  window_profiles_button_edit_clicked ();

}


void
on_button_profiles_close_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  window_profiles_close ();

}


gboolean
on_window_profile_delete_event         (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  window_profile_close ();

  return TRUE;
}


void
on_button_profile_cancel_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  window_profile_close ();

}


void
on_button_profile_ok_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{

  window_profile_button_ok_clicked ();

}


gboolean
on_window_yesno_delete_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  window_yesno_close ();
  return TRUE;
}


void
on_button_yesno_cancel_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  window_yesno_button_cancel_clicked ();

}


void
on_button_yesno_ok_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  window_yesno_button_ok_clicked ();

}


gboolean
on_window_chat_delete_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  window_chat_close (widget);
  return TRUE;
}


void
on_button_chat_close_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  window_chat_close ((GtkWidget*) button);
}


void
on_button_main_menu_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button_main_status_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button_main_add_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  my_create_window_contact (NULL, 0);

}


gboolean
on_window_contact_delete_event         (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  window_contact_close (widget);
  return TRUE;
}


void
on_button_contact_cancel_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  window_contact_close ((GtkWidget*) button);

}


void
on_button_contact_ok_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  window_contact_ok_clicked ((GtkWidget*) button);

}


void
on_button_message_ok_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  window_message_button_ok_clicked (GTK_WIDGET (button));

}


void
on_button_card_import_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  window_card_button_import_clicked ();

}


void
on_button_card_export_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  window_card_button_export_clicked ();

}


gboolean
on_window_card_delete_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  window_card_close ();

  return FALSE;
}


gboolean
on_window_search_delete_event          (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  window_search_close ();

  return TRUE;
}


void
on_button_search_ok_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  window_search_button_ok_clicked ();

}


void
on_button_search_add_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  window_search_button_add_clicked ();
}


void
on_button_search_clear_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  pubdir_list_clear ();
  window_search_update ();

}


void
on_button_search_close_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  window_search_close ();

}


void
on_button_search_message_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  window_search_button_message_clicked ();

}


gboolean
on_window_sendfile_delete_event        (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_button_sendfile_file_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  window_sendfile_button_file_clicked (GTK_WIDGET (button));

}


void
on_button_sendfile_cancel_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{

}


gboolean
on_fileselection_sendfile_delete_event (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return FALSE;
}



void
on_button_sendfile_send_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{

  window_sendfile_button_send_clicked (GTK_WIDGET (button));
}


gboolean
on_textview_bottom_key_press_event     (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  if (event->keyval == GDK_Return)
  {
    window_chat_button_send_clicked ((GTK_WIDGET (widget)));
    return TRUE;
  }
  return FALSE;
}

