/*
** TleenX3 (Tlen.pl Client)
** Copyright (c) 2004 Hubert Sokoowski <who_ami@tlen.pl>
**                    Pawe Biliski <rael@fr.pl>
**
** This code is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
**
*/






#include "icons.h"
#include "support.h"
#include "main.h"
#include "lists.h"

static
GtkWidget *icons_tlen[ICONS_TLEN_NUM];

static
GtkWidget *_icons_tlen_create (gint i);


GtkWidget *icons_tlen_get (gint status)
{
  if (!icons_tlen)
    return NULL;
  if (status < ICONS_TLEN_NUM)
    return icons_tlen[status];
  return NULL;
}

void icons_tlen_create()
{
  gint i;

  for (i = 0; i < ICONS_TLEN_NUM; i++)
  {
    if (!(icons_tlen[i]))
    {
      icons_tlen[i] = _icons_tlen_create (i);
      gtk_widget_show (icons_tlen[i]);
    }
  }
}

static
GtkWidget *_icons_tlen_create (gint status)
{
  switch(status)
  {
    case USER_STATUS_UNAVAILABLE:
      return create_pixmap(window_main,"offline.png");
    case USER_STATUS_AWAY:
      return create_pixmap(window_main,"away.png");
    case USER_STATUS_DND:
      return create_pixmap(window_main,"occupied.png");
    case USER_STATUS_EXT_AWAY:
      return create_pixmap(window_main,"beback.png");
    case USER_STATUS_CHATTY:
      return create_pixmap(window_main,"chat.png");
    case USER_STATUS_INVISIBLE:
      return create_pixmap(window_main,"invisible.png");
    case USER_STATUS_AVAILABLE:
      return create_pixmap(window_main,"online.png");
    default:
      return create_pixmap(window_main,"offline.png");
  }
}

