/*
** TleenX3 (Tlen.pl Client)
** Copyright (c) 2004 Hubert Sokoowski <who_ami@tlen.pl>
**                    Pawe Biliski <rael@fr.pl>
**
** This code is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
**
*/


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <libtlen2/libtlen2.h>

#include "interface.h"
#include "support.h"
#include "window-main.h"
#include "window-login.h"
#include "tlen-events.h"
#include "tlen.h"
#include "main.h"
#include "conf.h"

GtkWidget *window_main; // main window
GtkWidget *window_chat; // chat window
GtkWidget *window_login; // login window
GtkWidget *window_profiles; // profiles window
GtkWidget *window_profile; // profile window
GtkWidget *window_yesno; // yes-no window
GtkWidget *window_card; // card window
GtkWidget *window_search; // search window


//global variables, remember to free pointers in global_variables_free
gchar *config_dir; //directory with config files
Profile *profile; //main profile
gchar *datefg, *nickfg;
//global variables end!!!


int
main (int argc, char *argv[])
{

//  if (argc != 3)
//  {
//    printf ("usage: %s: <login> <password>\n", argv[0]);
//    return 1;
//  }
  gtk_set_locale ();
  gtk_init (&argc, &argv);
  tlen_init ();
#ifndef __WIN32__
  tlen_debug_set (TLEN_DEBUG_HIGH);
#endif

#ifdef __WIN32__
  add_pixmap_directory (".\\pixmaps");
  add_pixmap_directory ("..\\pixmaps");
#else
  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");
  add_pixmap_directory ("./pixmaps");
  add_pixmap_directory ("../pixmaps");
#endif

  config_dir = g_strdup (".");
  conf_read_profiles ();
  datefg = g_strdup ("#808080");
  nickfg = g_strdup ("#FF6600");
  my_create_window_login ();

  gtk_main ();
  if (profile)
    tlen_connection_delete (profile->tc);
  return 0;
}

void profile_exit (UserState state)
{
  profile->state = state;
  if (!profile->tc || (profile->tc->state != TLEN_STATE_LOGGED))
    main_quit ();
  else
    tc_close (profile);
}

void  main_quit (void)
{
  gtk_main_quit ();
  global_variables_free ();
  list_free ();
}

void global_variables_free ()
{
  g_free (config_dir);
  g_free (datefg);
  g_free (nickfg);
  config_dir = NULL;
}
