/*
** TleenX3 (Tlen.pl Client)
** Copyright (c) 2004 Hubert Sokoowski <who_ami@tlen.pl>
**                    Pawe Biliski <rael@fr.pl>
**
** This code is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
**
*/






#include "menu.h"
#include "main.h"
#include "lists.h"
#include "utils.h"
#include "window-misc.h"
#include "window-tuba.h"
#include "window-chat.h"
#include "window-main.h"
#include "window-p2p.h"
#include "support.h"
#include "interface.h"

static
void _on_menu_user_clipboard (User *user);
static
void _on_menu_user_mesg (const gchar *jid);
static
void _on_menu_user_check (const gchar *jid);
static
void _on_menu_user_edit (User *user);
static
void _on_menu_user_delete (User *user);
static
void _delete_user (gpointer d1, gpointer d2);
static
void _on_menu_user_chat (User *user);
static
void _on_menu_user_pubdir (User *user);
static
void _on_menu_user_sendfile (const gchar *jid);


void
on_wyslij_plik_activate            (GtkMenuItem     *menuitem,
                                    gpointer         user_data)
{
  my_create_window_sendfile (NULL);
}

void
on_wyszukiwanie_activate            (GtkMenuItem     *menuitem,
                                     gpointer         user_data)
{
  if (!window_search)
    my_create_window_search ();
}

void
on_wizytowka_activate            (GtkMenuItem     *menuitem,
                                  gpointer         user_data)
{
  if (!window_card)
  {
    window_card = create_window_card ();
    gtk_widget_show (window_card);
    window_card_hide_thobber ();
  }
}

void
on_o_programie_activate            (GtkMenuItem     *menuitem,
                                    gpointer         user_data)
{
  GtkWidget *window;

  window = create_window_about ();
  gtk_widget_show (window);
}

void
on_dodaj_kontakt_activate            (GtkMenuItem     *menuitem,
                                      gpointer         user_data)
{
  my_create_window_contact (NULL, 0);
}

void
on_wyslij_wiadomosc_activate            (GtkMenuItem     *menuitem,
                                         gpointer         user_data)
{
  my_create_window_message (NULL, NULL);
}

void
on_wyjscie_activate            (GtkMenuItem     *menuitem,
                                gpointer         user_data)
{
  profile_exit (USER_STATE_QUIT);
}

void
on_wyloguj_profil_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  profile_exit (USER_STATE_CHANGE_PROFILE);
}

gint menu_show (GtkWidget *menu, GdkEvent *event)
{
  if (event->type == GDK_BUTTON_PRESS)
  {
    GdkEventButton *bevent = (GdkEventButton *) event;

    gtk_menu_popup (GTK_MENU (menu), NULL, NULL, NULL, NULL,
                    bevent->button, bevent->time);
    return TRUE;
  }
  return FALSE;
}

void menu_status_response (gchar *s)
{
  gint status2 = 0;

  if (!s)
    return;
  if (!tlen_strcmp (s, "1"))
  {
    status2 = USER_STATUS_AVAILABLE;
//    autoaway = TRUE;
  }
  if (!tlen_strcmp (s, "2"))
  {
    status2 = USER_STATUS_CHATTY;
//    autoaway = FALSE;
  }
  if (!tlen_strcmp (s, "3"))
  {
    status2 = USER_STATUS_DND;
//    autoaway = FALSE;
  }
  if (!tlen_strcmp (s, "4"))
  {
    status2 = USER_STATUS_AWAY;
//    autoaway = FALSE;
  }
  if (!tlen_strcmp (s, "5"))
  {
    status2 = USER_STATUS_EXT_AWAY;
//    autoaway = FALSE;
  }
  if (!tlen_strcmp (s, "6"))
  {
    status2 = USER_STATUS_INVISIBLE;
//    autoaway = FALSE;
  }
  if (!tlen_strcmp (s, "7"))
  {
//    if (cant_stop)
//      return;
//    work_offline ();
    return;
  }
  if (!tlen_strcmp (s, "8"))
  {
//    my_create_window_desc ();
    return;
  }
  if (status2 == profile->status)
    return;
  profile->status = status2;
  set_status (status2);
}

void menu_user_open (GtkWidget *widget, GdkEventButton  *event)
{
  GtkTreeView *treeview = (GTK_TREE_VIEW (widget));
  GtkTreeSelection *selection;
  GtkTreeModel *model;
  GtkTreeIter iter;
  guint status;
  gchar *s;
  GtkWidget *menu;
  GtkWidget *image;
  GtkWidget *menu_items;
  User *user;
  gchar *jid;

  selection = gtk_tree_view_get_selection (treeview);
  if ((event->type == GDK_BUTTON_RELEASE) &&
      (event->button == 3))
  {
    if (gtk_tree_selection_get_selected (selection, &model, &iter))
    {
      gtk_tree_model_get (model, &iter,
                          0, &status,
                          -1);
      //      if((status==0) || (status==1))
      //        return TRUE;
      gtk_tree_model_get (model, &iter,
                          1, &jid,
                          -1);
      user = list_user_item_get (jid);
      if (!user)
        return;

      menu = gtk_menu_new ();
      menu_items = gtk_image_menu_item_new_with_label (jid);
      gtk_menu_append (GTK_MENU (menu), menu_items);
      gtk_widget_show (menu_items);
      gtk_widget_set_sensitive (menu_items, FALSE);
      s = user_description (user);
      if (s)
      {
        menu_items = gtk_image_menu_item_new_with_label (s);
        gtk_menu_append (GTK_MENU (menu), menu_items);
        gtk_widget_show (menu_items);
        gtk_widget_set_sensitive (menu_items, FALSE);
      }

      menu_items = gtk_menu_item_new ();
      gtk_widget_show (menu_items);
      gtk_container_add (GTK_CONTAINER (menu), menu_items);
      gtk_widget_set_sensitive (menu_items, FALSE);

      if (s)
      {
        menu_items = gtk_image_menu_item_new_with_mnemonic("Skopiuj opis do schowka");
        gtk_menu_append (GTK_MENU (menu), menu_items);
        g_signal_connect_swapped (G_OBJECT (menu_items), "activate",
                                  G_CALLBACK (_on_menu_user_clipboard),
                                  (gpointer) user);
        gtk_widget_show (menu_items);
        g_free (s);
      }
      if (user)
        if (user_subscribed (user))
        {
          menu_items = gtk_image_menu_item_new_with_mnemonic ("Rozmowa");
          gtk_menu_append (GTK_MENU (menu), menu_items);
          g_signal_connect_swapped (G_OBJECT (menu_items), "activate",
                                    G_CALLBACK (_on_menu_user_chat),
                                    (gpointer) user);
          gtk_widget_show (menu_items);
          image = create_pixmap (window_main, "menu-rozmowa.png");
          gtk_widget_show (image);
          gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(menu_items), image);
        }

      s = utf("Wiadomo");
      menu_items = gtk_image_menu_item_new_with_label (s);
      g_free (s);
      gtk_menu_append (GTK_MENU (menu), menu_items);
      g_signal_connect_swapped (G_OBJECT (menu_items), "activate",
                                G_CALLBACK (_on_menu_user_mesg),
                                (gpointer) user->jid);
      gtk_widget_show (menu_items);
      image = create_pixmap (window_main, "menu-wiadomosc.png");
      gtk_widget_show (image);
      gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(menu_items), image);

      s = utf("Wylij plik");
      menu_items = gtk_image_menu_item_new_with_label (s);
      g_free (s);
      gtk_menu_append (GTK_MENU (menu), menu_items);
      g_signal_connect_swapped (G_OBJECT (menu_items), "activate",
                                G_CALLBACK (_on_menu_user_sendfile),
                                (gpointer) user->jid);
      gtk_widget_show (menu_items);
      gtk_widget_set_sensitive (menu_items, FALSE);
      image = create_pixmap (window_main, "menu-sendfile.png");
      gtk_widget_show (image);
      gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(menu_items), image);

      menu_items = gtk_image_menu_item_new_with_label ("Edycja danych osoby");
      gtk_menu_append (GTK_MENU (menu), menu_items);
      g_signal_connect_swapped (G_OBJECT (menu_items), "activate",
                                G_CALLBACK (_on_menu_user_edit),
                                (gpointer) user);
      gtk_widget_show (menu_items);
      image = create_pixmap (window_main, "menu-edycja.png");
      gtk_widget_show (image);
      gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(menu_items), image);

      s = utf("Katalog publiczny");
      menu_items = gtk_image_menu_item_new_with_label (s);
      g_free (s);
      gtk_menu_append (GTK_MENU (menu), menu_items);
      g_signal_connect_swapped (G_OBJECT (menu_items), "activate",
                                G_CALLBACK (_on_menu_user_check),
                                (gpointer) user->jid);
      gtk_widget_show (menu_items);
      image = create_pixmap (window_main, "menu-katalog.png");
      gtk_widget_show (image);
      gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(menu_items), image);
      g_signal_connect_swapped (G_OBJECT (menu_items), "activate",
                                G_CALLBACK (_on_menu_user_pubdir),
                                (gpointer) user);

      menu_items = gtk_menu_item_new ();
      gtk_widget_show (menu_items);
      gtk_container_add (GTK_CONTAINER (menu), menu_items);
      gtk_widget_set_sensitive (menu_items, FALSE);

      s = utf ("Usu");
      menu_items = gtk_image_menu_item_new_with_label (s);
      g_free (s);
      gtk_menu_append (GTK_MENU (menu), menu_items);
      g_signal_connect_swapped (G_OBJECT (menu_items), "activate",
                                G_CALLBACK (_on_menu_user_delete),
                                (gpointer) user);
      gtk_widget_show (menu_items);
      image = create_pixmap (window_main, "menu-usun.png");
      gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(menu_items), image);
      gtk_widget_show (image);

      gtk_menu_popup (GTK_MENU (menu), NULL, NULL, NULL, NULL,
                      1, event->time);
      return;
    }
  }
  /*
     else
     if (event->type==GDK_BUTTON_RELEASE &&
     event->button==1)
     {
  //    GtkTreePath *treepath;

  if (gtk_tree_selection_get_selected (selection, &model, &iter))
  {
  //      gtk_tree_model_get (model, &iter,
  //                          0, &status,
  //                          -1);
  //      if(status!=1)
  //        return TRUE;
  //      gtk_tree_model_get (model, &iter,
  //                          2, &s,
  //                          -1);
  //      treepath=gtk_tree_path_new_from_string(s);
  //      if(gtk_tree_view_row_expanded(treeview,treepath))
  //        gtk_tree_view_collapse_row(treeview, treepath);
  //      else
  //        gtk_tree_view_expand_row(treeview,treepath,FALSE);
  //      gtk_tree_path_free(treepath);
  return FALSE;
  }
  }
   */
  return;
}

static
void _on_menu_user_pubdir (User *user)
{
  if (user)
    window_search_check (user->jid);
}

static
void _on_menu_user_clipboard (User *user)
{
  GtkClipboard *defaultClip;
  gchar *desc;

  if (!user)
    return;
  desc = user->description;
  defaultClip = gtk_clipboard_get (GDK_SELECTION_PRIMARY);
  if (desc)
  {
    gtk_clipboard_set_text (defaultClip, desc, tlen_strlen (desc));
  }
}

static
void _on_menu_user_sendfile (const gchar *jid)
{
  my_create_window_sendfile (jid);
}

static
void _on_menu_user_mesg (const gchar *jid)
{
  my_create_window_message (jid, NULL);
}

static
void _on_menu_user_check (const gchar *jid)
{
//  if (!window_search)
//    my_create_window_search ();
//  window_search_check ((gchar *) jid);
}

static
void _on_menu_user_edit (User *user)
{
  my_create_window_contact (user->jid, user->type);
}

static
void _on_menu_user_delete (User *user)
{
  my_create_window_yesno ("Czy napewno chcesz usun kontakt z listy?",
                          _delete_user, NULL, user, NULL);
}

static
void _delete_user (gpointer d1, gpointer d2)
{
  User *u = (User*) d1;
  gboolean ret;

  if (!u)
    return;
  ret = tlen_contact_remove (profile->tc, u->jid);
  if (!ret)
  {
    info ("Wystpi bd podczas usuwania kontaktu.");
    return;
  }
  if (user_subscribed (u))
  {
    ret = tlen_unsubscribe_request (profile->tc, u->jid);
    if (!ret)
    {
      info ("Wystpi bd podczas usuwania kontaktu.");
      return;
    }
  }
  list_user_item_del (u);
  window_main_treeview_update ();
}


static
void _on_menu_user_chat (User *user)
{
  window_chat_append (user->jid, NULL, NULL, FALSE);
}


