/*
** TleenX3 (Tlen.pl Client)
** Copyright (c) 2004 Hubert Sokoowski <who_ami@tlen.pl>
**                    Pawe Biliski <rael@fr.pl>
**
** This code is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
**
*/





#ifndef __UTILS_H__
#define __UTILS_H__

#include <gtk/gtk.h>
#include <sys/types.h>
#include "lists.h"
#include <libtlen2/libtlen2.h>

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  gtk_object_set_data_full (GTK_OBJECT (component), name, \
    gtk_widget_ref (widget), (GtkDestroyNotify) gtk_widget_unref)


const gchar *textview_get_text(GtkWidget *textview);
gchar *fromutf(const gchar *in);
gchar *utf(const gchar *in);
void info (const gchar *s1);
void textview_append (GtkWidget *textview, const gchar *str, gint scroll,
                      const gchar *tag, const gchar *tag2);
void textview_clear (GtkWidget *textview);
void textview_append_message (GtkWidget *textview, const gchar *jid,
                              const gchar *body, const gchar *stamp,
                              gboolean from);
gchar *get_localtime(const time_t *t2);
UserStatus status_tlen2user (TlenPresenceStatus status);
TlenPresenceStatus status_user2tlen (UserStatus status);
void set_status (UserStatus status);
void status_button_set (UserStatus _status);


#endif

