/*
** TleenX3 (Tlen.pl Client)
** Copyright (c) 2004 Hubert Sokoowski <who_ami@tlen.pl>
**                    Pawe Biliski <rael@fr.pl>
**
** This code is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
**
*/


#include "window-p2p.h"
#include "interface.h"
#include "support.h"
#include "utils.h"
#include "lists.h"


void fileselection_sendfile_button_ok_clicked (P2p *p)
{
  GtkWidget *widget;
  gchar *s;
  gsize r, w;
  GError *error;

  widget = lookup_widget (p->window, "entry_path");
  s = (gchar *)
          gtk_file_selection_get_filename(GTK_FILE_SELECTION(p->fileselection));
  if(s[tlen_strlen(s)-1] == '/')
    return;
  s = g_filename_to_utf8 (s, -1, &r, &w, &error);
  gtk_entry_set_text (GTK_ENTRY(widget), s);
  g_free (s);
  gtk_widget_destroy (p->fileselection);
}

void my_create_fileselection_sendfile (P2p *p)
{
  GtkWidget *window, *button;

  window = create_fileselection_sendfile ();
  p->fileselection = window;
  button = lookup_widget (window, "button_fileselection_sendfile_ok");
  g_signal_connect_swapped ((gpointer) button, "clicked",
                            G_CALLBACK (fileselection_sendfile_button_ok_clicked),
                            p);
  gtk_widget_show (window);
}

void window_sendfile_button_file_clicked (GtkWidget *window)
{
  P2p *p;

  p = list_p2p_item_get_by_window (window);
  my_create_fileselection_sendfile (p);
}

void window_sendfile_button_send_clicked (GtkWidget *window)
{
  GtkWidget *widget;
  gchar *id, *path, *filename;
  gsize bytes;

  widget = lookup_widget (window, "entry_id");
  id = (gchar*) gtk_entry_get_text (GTK_ENTRY(widget));
  if (!tlen_strlen (id))
  {
    info ("Nieznany odbiorca");
    return;
  }
  widget = lookup_widget (window, "entry_path");
  path = (gchar*) gtk_entry_get_text (GTK_ENTRY(widget));
  if (!tlen_strlen (path))
  {
    info ("Musisz okrelic ciek do pliku");
    return;
  }
  filename = g_filename_from_utf8 (path, -1, NULL, &bytes, NULL);
  if (!tlen_p2p_sendfile (profile->tc, id, filename))
    info ("Nie mona wysa pliku");
  g_free (filename);
}

void window_sendfile_close (P2p *p)
{
  gtk_widget_destroy (p->fileselection);
}

void my_create_window_sendfile (const gchar *to)
{
  GtkWidget *window, *entry;
  P2p *p;

  window = create_window_sendfile ();
  if (to)
  {
    entry = lookup_widget (window, "entry_id");
    gtk_entry_set_text (GTK_ENTRY (entry), to);
  }
  p = list_p2p_item_new ();
  p->window = window;
  list_p2p_item_add (p);
  gtk_widget_show (window);
}

