/*
** TleenX3 (Tlen.pl Client)
** Copyright (c) 2004 Hubert Sokoowski <who_ami@tlen.pl>
**                    Pawe Biliski <rael@fr.pl>
**
** This code is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
**
*/




#include "window-tuba.h"
#include "window-chat.h"
#include "window-misc.h"

#include "main.h"
#include "support.h"
#include "utils.h"
#include "interface.h"
#include "lists.h"
#include "icons.h"

#include <string.h>

static gchar *search_tc_columns[SEARCH_TC_COLUMNS] =
{
  "Status", "ID", "Wiek", "Pe", "Miasto", "Imi", "Nazwisko", "Nick", "Email",
  "Poszukuje", "Szkoa", "Zawd", "Gosowe", "Plany"
};//tytuly kolumn w treeview window_search


static gchar *look_for[] = {
  "", "rozmowa", "przyja", "romans", "mio"
};

static
gchar *job[] = {
  "",
  "ucze",
  "student",
  "rolnik",
  "meneder",
  "specjalista",
  "urzdnik",
  "bezrobotny",
  "emeryt,rencista",
  "gospodyni",
  "nauczyciel",
  "lekarz",
  "inny"
};

static
gchar *plans[] = {
  "", "kino"
};



static GSList *pubdir_list;

static
void search_window_pixbuf(GtkTreeViewColumn *tree_column,
                          GtkCellRenderer   *cell,
                          GtkTreeModel      *model,
                          GtkTreeIter       *iter,
                          gpointer           data);
static
void search_window_text (GtkTreeViewColumn *tree_column,
                         GtkCellRenderer   *cell,
                         GtkTreeModel      *model,
                         GtkTreeIter       *iter,
                         gpointer           data);


void window_search_button_message_clicked ()
{
  GtkTreeSelection *selection;
  GtkTreeView *treeview;
  GtkTreeModel *model;
  GtkTreeIter iter;
  gchar *jid;

  treeview = (GtkTreeView*)lookup_widget(window_search,"treeview");
  selection = gtk_tree_view_get_selection(treeview);
  if (! gtk_tree_selection_get_selected (selection, NULL, &iter))
    return;
  model = gtk_tree_view_get_model (treeview);
  gtk_tree_model_get (model, &iter, SEARCH_TC_ID, &jid, -1);
  my_create_window_message (jid, NULL);
}

void window_search_button_add_clicked ()
{
  GtkTreeSelection *selection;
  GtkTreeView *treeview;
  GtkTreeModel *model;
  GtkTreeIter iter;
  gchar *jid;

  treeview = (GtkTreeView*)lookup_widget(window_search,"treeview");
  selection = gtk_tree_view_get_selection(treeview);
  if (! gtk_tree_selection_get_selected (selection, NULL, &iter))
    return;
  model = gtk_tree_view_get_model (treeview);
  gtk_tree_model_get (model, &iter, SEARCH_TC_ID, &jid, -1);
  if(list_user_item_get(jid))
  {
    info ("Wybrany uytkownik znajduje si na licie kontaktw");
    return;
  }
  my_create_window_contact(jid, 0);
}

void window_search_button_ok_clicked ()
{
  TlenPubdirItem *pubdir;
  GtkWidget *widget;
  gchar *s;


  pubdir = tlen_pubdir_item_new();

  widget = lookup_widget(window_search,"entry_name");
  s = fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(tlen_strlen(s)>0)
    pubdir->firstname = s;

  widget = lookup_widget(window_search,"entry_surname");
  s = fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(tlen_strlen(s)>0)
    pubdir->lastname = s;

  widget = lookup_widget(window_search,"entry_nick");
  s = fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(tlen_strlen(s)>0)
    pubdir->nick = s;

  widget = lookup_widget(window_search,"entry_gender");
  s = fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(!tlen_strcmp(s,"kobieta"))
    pubdir->gender = TLEN_PUBDIR_GENDER_FEMALE;
  else if(!tlen_strcmp(s,"mczyzna"))
    pubdir->gender = TLEN_PUBDIR_GENDER_MALE;
  else
    pubdir->gender=TLEN_PUBDIR_GENDER_NONE;
  g_free(s);

  widget = lookup_widget(window_search,"entry_city");
  s = fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(tlen_strlen(s)>0)
    pubdir->city = s;

  widget = lookup_widget(window_search,"entry_email");
  s = fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(tlen_strlen(s)>0)
    pubdir->email = s;

  widget = lookup_widget(window_search,"spinbutton_agefrom");
  pubdir->age_min = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(widget));
  widget = lookup_widget(window_search,"spinbutton_ageto");
  pubdir->age_max = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(widget));
  widget = lookup_widget(window_search,"entry_status");
  s = fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(!tlen_strcmp(s,"dostpny"))
    pubdir->status = TLEN_PUBDIR_STATUS_AVAILABLE;
  else if(!tlen_strcmp(s,"porozmawiajmy"))
    pubdir->status = TLEN_PUBDIR_STATUS_CHATTY;
  g_free(s);

  widget = lookup_widget(window_search,"entry_look");
  s = fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(!tlen_strcmp(s,""))
    pubdir->look_for = TLEN_PUBDIR_LOOK_NONE;
  else if(!tlen_strcmp(s,"rozmowa"))
    pubdir->look_for = TLEN_PUBDIR_LOOK_TALK;
  else if(!tlen_strcmp(s,"przyja"))
    pubdir->look_for = TLEN_PUBDIR_LOOK_FRIEND;
  else if(!tlen_strcmp(s,"romans"))
    pubdir->look_for = TLEN_PUBDIR_LOOK_FLIRT;
  else if(!tlen_strcmp(s,"mio"))
    pubdir->look_for = TLEN_PUBDIR_LOOK_LOVE;
  g_free(s);

  widget = lookup_widget(window_search,"entry_school");
  s = fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(tlen_strlen(s)>0)
    pubdir->school = s;

  widget = lookup_widget(window_search,"entry_job");
  s = fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(!tlen_strcmp(s,""))
    pubdir->job = TLEN_PUBDIR_JOB_NONE;
  else if(!tlen_strcmp(s,"ucze"))
    pubdir->job = TLEN_PUBDIR_JOB_UCZEN;
  else if(!tlen_strcmp(s,"student"))
    pubdir->job = TLEN_PUBDIR_JOB_STUDENT;
  else if(!tlen_strcmp(s,"rolnik"))
    pubdir->job = TLEN_PUBDIR_JOB_ROLNIK;
  else if(!tlen_strcmp(s,"meneder"))
    pubdir->job = TLEN_PUBDIR_JOB_MENEDZER;
  else if(!tlen_strcmp(s,"specjalista"))
    pubdir->job = TLEN_PUBDIR_JOB_SPEC_WOL;
  else if(!tlen_strcmp(s,"urzdnik"))
    pubdir->job = TLEN_PUBDIR_JOB_UUA;
  else if(!tlen_strcmp(s,"emeryt,rencista"))
    pubdir->job = TLEN_PUBDIR_JOB_EMERYT;
  else if(!tlen_strcmp(s,"gospodyni"))
    pubdir->job = TLEN_PUBDIR_JOB_GOSPODYNI;
  else if(!tlen_strcmp(s,"nauczyciel"))
    pubdir->job = TLEN_PUBDIR_JOB_NAUCZYCIEL;
  else if(!tlen_strcmp(s,"lekarz"))
    pubdir->job = TLEN_PUBDIR_JOB_LEKARZ;
  else if(!tlen_strcmp(s,"inny"))
    pubdir->job = TLEN_PUBDIR_JOB_INNY;
  else if(!tlen_strcmp(s,"bezrobotny"))
    pubdir->job = TLEN_PUBDIR_JOB_BEZROBOTNY;
  g_free(s);

  widget = lookup_widget(window_search,"entry_voice");
  s = fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(!tlen_strcmp(s,"nie"))
    pubdir->voice = TLEN_PUBDIR_VOICE_DISABLED;
  else
    pubdir->voice = TLEN_PUBDIR_VOICE_ENABLED;
  g_free(s);

  widget = lookup_widget(window_search,"entry_plans");
  s = fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(!tlen_strcmp(s,""))
    pubdir->plans = TLEN_PUBDIR_WANT_NONE;
  else if(!tlen_strcmp(s,"kino"))
    pubdir->plans = TLEN_PUBDIR_WANT_CINEMA;
  g_free(s);

  widget = lookup_widget(window_search,"entry_id");
  s = fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(tlen_strlen(s)>0)
    pubdir->id = s;

  tlen_pubdir_search(profile->tc,pubdir);
  tlen_pubdir_item_free(pubdir);
  widget = lookup_widget(window_search,"thobber");
  gtk_widget_show(widget);
}

void window_search_check(gchar *id)
{
  GtkWidget *widget;
  TlenPubdirItem *pubdir;
  gchar *s = NULL;

  if (!window_search)
    my_create_window_search ();
  if((s = strchr(id, '@')))
    *s = '\0';
  widget = lookup_widget(window_search,"entry_name");
  gtk_entry_set_text(GTK_ENTRY(widget), "");

  widget = lookup_widget(window_search,"entry_surname");
  gtk_entry_set_text(GTK_ENTRY(widget), "");

  widget = lookup_widget(window_search,"entry_nick");
  gtk_entry_set_text(GTK_ENTRY(widget), "");

  widget = lookup_widget(window_search,"entry_gender");
  gtk_entry_set_text(GTK_ENTRY(widget), "");

  widget = lookup_widget(window_search,"entry_city");
  gtk_entry_set_text(GTK_ENTRY(widget), "");

  widget = lookup_widget(window_search,"entry_email");
  gtk_entry_set_text(GTK_ENTRY(widget), "");

  widget = lookup_widget(window_search,"spinbutton_agefrom");
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), 0);
  widget = lookup_widget(window_search,"spinbutton_ageto");
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), 0);

  widget = lookup_widget(window_search,"entry_status");
  gtk_entry_set_text(GTK_ENTRY(widget), "");

  widget = lookup_widget(window_search,"entry_look");
  gtk_entry_set_text(GTK_ENTRY(widget), "");

  widget = lookup_widget(window_search,"entry_school");
  gtk_entry_set_text(GTK_ENTRY(widget), "");

  widget = lookup_widget(window_search,"entry_job");
  gtk_entry_set_text(GTK_ENTRY(widget), "");

  widget = lookup_widget(window_search,"entry_voice");
  gtk_entry_set_text(GTK_ENTRY(widget), "nie");

  widget = lookup_widget(window_search,"entry_plans");
  gtk_entry_set_text(GTK_ENTRY(widget), "");

  widget = lookup_widget(window_search,"entry_id");
  gtk_entry_set_text(GTK_ENTRY(widget), id);
  pubdir = tlen_pubdir_item_new();
  pubdir->id = g_strdup(id);

  tlen_pubdir_search (profile->tc, pubdir);
  tlen_pubdir_item_free (pubdir);
  if(s)
    *s = '@';
  widget = lookup_widget(window_search,"thobber");
  gtk_widget_show(widget);
}

void my_create_window_search()
{
  GtkTreeView *treeview;
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;
  gchar *s;
  gint i;

  window_search = create_window_search();
  treeview = (GtkTreeView*) lookup_widget(window_search, "treeview");

  renderer = gtk_cell_renderer_pixbuf_new();
  column = gtk_tree_view_column_new();
  gtk_tree_view_column_set_title(column,"ID");
  gtk_tree_view_column_pack_start(column, renderer, FALSE);
  gtk_tree_view_column_set_cell_data_func (column, renderer,
                                           search_window_pixbuf, NULL, NULL);

  renderer = gtk_cell_renderer_text_new ();
  gtk_tree_view_column_pack_start(column, renderer, FALSE);
  gtk_tree_view_column_set_cell_data_func (column, renderer,
                                           search_window_text, NULL, NULL);
  gtk_tree_view_append_column (treeview, column);

  for(i = SEARCH_TC_AGE; i < SEARCH_TC_COLUMNS; i++)
  {
    renderer = gtk_cell_renderer_text_new ();
    s = utf(search_tc_columns[i]);
    g_object_set_data (G_OBJECT (renderer), "column", (gint *)i);
    gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                                 -1, s, renderer,
                                                 "text", i,
                                                 NULL);
    g_free(s);
  }

  window_search_update();
  gtk_widget_show(window_search);
}

void pubdir_list_add(TlenPubdirItem *pubdir)
{
  pubdir_list = g_slist_append(pubdir_list, (gpointer*)pubdir);
}

void pubdir_list_clear()
{
  TlenPubdirItem *pubdir;
  GSList *l = pubdir_list;

  while(l)
  {
    pubdir = (TlenPubdirItem*)l->data;
    tlen_pubdir_item_free(pubdir);
    l = l->next;
  }
  g_slist_free(pubdir_list);
  pubdir_list = NULL;
}

void window_search_update()
{
  GtkWidget *image;
  GtkTreeStore *store;
  GtkTreeIter iter;
  GSList *l;
  TlenPubdirItem *pubdir;
  gchar *s=NULL;
  GtkWidget *treeview;

  store = gtk_tree_store_new(SEARCH_TC_COLUMNS,
                             G_TYPE_UINT,//status
                             G_TYPE_STRING,//jid
                             G_TYPE_UINT,//wiek
                             G_TYPE_STRING,//plec
                             G_TYPE_STRING,//miasto
                             G_TYPE_STRING,//imie
                             G_TYPE_STRING,//nazwisko
                             G_TYPE_STRING,//nick
                             G_TYPE_STRING,//email
                             G_TYPE_STRING,//poszukuje
                             G_TYPE_STRING,//szkola
                             G_TYPE_STRING,//zawod
                             G_TYPE_STRING,//glosowe
                             G_TYPE_STRING//plany
                             );
  for(l = pubdir_list; l; l=l->next)
  {
    guint status;

    pubdir = (TlenPubdirItem*) l->data;
    status = pubdir->status;
    gtk_tree_store_append (store, &iter,NULL);
    if(status == 0)
      status = USER_STATUS_UNAVAILABLE;
    else
    if(status == 1)
      status = USER_STATUS_INVISIBLE;
    else
      status = status_tlen2user (status);
    gtk_tree_store_set (store, &iter,
                        SEARCH_TC_STATUS, status,
                        SEARCH_TC_ID, pubdir->id,
                        SEARCH_TC_AGE, pubdir->age,
                        -1);

    switch(pubdir->gender)
    {
      case TLEN_PUBDIR_GENDER_FEMALE:
        s = utf("kobieta");
        break;
      case TLEN_PUBDIR_GENDER_MALE:
        s = utf("mczyzna");
        break;
      case TLEN_PUBDIR_GENDER_NONE:
        s = utf("");
        break;
    }
    gtk_tree_store_set (store, &iter,
                        SEARCH_TC_GENDER, s,
                        -1);
    g_free(s);

    s = utf(pubdir->city);
    gtk_tree_store_set (store, &iter,
                        SEARCH_TC_CITY, s,
                        -1);
    g_free(s);

    s = utf(pubdir->firstname);
    gtk_tree_store_set (store, &iter,
                        SEARCH_TC_FIRSTNAME, s,
                        -1);
    g_free(s);

    s = utf(pubdir->lastname);
    gtk_tree_store_set (store, &iter,
                        SEARCH_TC_SURNAME, s,
                        -1);
    g_free(s);

    s = utf(pubdir->nick);
    gtk_tree_store_set (store, &iter,
                        SEARCH_TC_NICK, s,
                        -1);
    g_free(s);

    s = utf(pubdir->email);
    gtk_tree_store_set (store, &iter,
                        SEARCH_TC_EMAIL, s,
                        -1);
    g_free(s);

    s = utf(look_for[pubdir->look_for]);
    gtk_tree_store_set (store, &iter,
                        SEARCH_TC_LOOK, s,
                        -1);
    g_free(s);

    s = utf(pubdir->school);
    gtk_tree_store_set (store, &iter,
                        SEARCH_TC_SCHOOL, s,
                        -1);
    g_free(s);

    s = utf(job[pubdir->job]);
    gtk_tree_store_set (store, &iter,
                        SEARCH_TC_JOB, s,
                        -1);
    g_free(s);

    if(pubdir->voice == TLEN_PUBDIR_VOICE_ENABLED)
      gtk_tree_store_set (store, &iter,
                          SEARCH_TC_VOICE, "tak",
                          -1);
    else
      gtk_tree_store_set (store, &iter,
                          SEARCH_TC_VOICE, "nie",
                          -1);

    s = utf(plans[pubdir->plans]);
    gtk_tree_store_set (store, &iter,
                        SEARCH_TC_PLANS, s,
                        -1);
    g_free(s);
  }

  treeview = lookup_widget(window_search, "treeview");
  gtk_tree_view_set_model(GTK_TREE_VIEW(treeview),
                          GTK_TREE_MODEL(store));
  g_object_unref(G_OBJECT(store));
  image=lookup_widget(window_search,"thobber");
  gtk_widget_hide(image);
}

void window_search_close (void)
{
  if (window_search)
  {
    gtk_widget_destroy (window_search);
    window_search = NULL;
    pubdir_list_clear ();
  }
}

void window_card_hide_thobber()
{
  GtkWidget *image;

  image = lookup_widget(window_card, "thobber");
  gtk_widget_hide(image);
}

void window_card_show_thobber()
{
  GtkWidget *image;

  image = lookup_widget(window_card, "thobber");
  gtk_widget_show(image);
}

void window_card_update (TlenPubdirItem *item)
{
  GtkWidget *widget;
  gchar *s;

  if (window_card)
  {
    window_card_hide_thobber ();
    widget = lookup_widget(window_card, "entry_surname");
    s = item->firstname;
    if(s)
    {
      s = utf(s);
      gtk_entry_set_text(GTK_ENTRY(widget), s);
      g_free(s);
    }
    else
      gtk_entry_set_text(GTK_ENTRY(widget), "");
    widget = lookup_widget(window_card, "entry_name");
    s = item->lastname;
    if(s)
    {
      s = utf(s);
      gtk_entry_set_text(GTK_ENTRY(widget), s);
      g_free(s);
    }
    else
      gtk_entry_set_text(GTK_ENTRY(widget), "");
    widget = lookup_widget(window_card, "entry_nick");
    s = item->nick;
    if(s)
    {
      s = utf(s);
      gtk_entry_set_text(GTK_ENTRY(widget), s);
      g_free(s);
    }
    else
      gtk_entry_set_text(GTK_ENTRY(widget), "");
    widget = lookup_widget(window_card, "entry_gender");
    switch(item->gender)
    {
      case TLEN_PUBDIR_GENDER_NONE:
        s="";
        break;
      case TLEN_PUBDIR_GENDER_FEMALE:
        s="kobieta";
        break;
      case TLEN_PUBDIR_GENDER_MALE:
        s="mczyzna";
        break;
    }
    if(s)
    {
      s=utf(s);
      gtk_entry_set_text(GTK_ENTRY(widget),s);
      g_free(s);
    }
    else
      gtk_entry_set_text(GTK_ENTRY(widget), "");
    widget=lookup_widget(window_card, "entry_city");
    s=item->city;
    if(s)
    {
      s=utf(s);
      gtk_entry_set_text(GTK_ENTRY(widget),s);
      g_free(s);
    }
    else
      gtk_entry_set_text(GTK_ENTRY(widget), "");
    widget=lookup_widget(window_card, "entry_email");
    s=item->email;
    if(s)
    {
      s=utf(s);
      gtk_entry_set_text(GTK_ENTRY(widget),s);
      g_free(s);
    }
    else
      gtk_entry_set_text(GTK_ENTRY(widget), "");
    widget=lookup_widget(window_card, "spinbutton_year");
    if(item->birthyear >= 1900)
      gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget),
                                item->birthyear);
    widget=lookup_widget(window_card, "entry_status");
    if(item->visible == TLEN_PUBDIR_VISIBLE_NO)
      gtk_entry_set_text(GTK_ENTRY(widget),"nie");
    else
      gtk_entry_set_text(GTK_ENTRY(widget),"tak");
    widget=lookup_widget(window_card, "entry_look");
    switch(item->look_for)
    {
      case TLEN_PUBDIR_LOOK_NONE:
        s="";
        break;
      case TLEN_PUBDIR_LOOK_TALK:
        s="rozmowa";
        break;
      case TLEN_PUBDIR_LOOK_FRIEND:
        s="przyjan";
        break;
      case TLEN_PUBDIR_LOOK_FLIRT:
        s="romans";
        break;
      case TLEN_PUBDIR_LOOK_LOVE:
        s="mio";
        break;
      default:
        s="";
    }
    s=utf(s);
    gtk_entry_set_text(GTK_ENTRY(widget),s);
    g_free(s);
    widget=lookup_widget(window_card, "entry_school");
    s=item->school;
    if(s)
    {
      s=utf(s);
      gtk_entry_set_text(GTK_ENTRY(widget),s);
      g_free(s);
    }
    else
      gtk_entry_set_text(GTK_ENTRY(widget), "");
    widget=lookup_widget(window_card, "entry_job");
    switch(item->job)
    {
      case TLEN_PUBDIR_JOB_NONE:
        s="";
        break;
      case TLEN_PUBDIR_JOB_UCZEN:
        s="ucze";
        break;
      case TLEN_PUBDIR_JOB_STUDENT:
        s="student";
        break;
      case TLEN_PUBDIR_JOB_ROLNIK:
        s="rolnik";
        break;
      case TLEN_PUBDIR_JOB_MENEDZER:
        s="meneder";
        break;
      case TLEN_PUBDIR_JOB_SPEC_WOL:
        s="specjalista";
        break;
      case TLEN_PUBDIR_JOB_UUA:
        s="urzdnik";
        break;
      case TLEN_PUBDIR_JOB_BEZROBOTNY:
        s="bezrobotny";
        break;
      case TLEN_PUBDIR_JOB_EMERYT:
        s="emeryt,rencista";
        break;
      case TLEN_PUBDIR_JOB_GOSPODYNI:
        s="gospodyni";
        break;
      case TLEN_PUBDIR_JOB_NAUCZYCIEL:
        s="nauczyciel";
        break;
      case TLEN_PUBDIR_JOB_LEKARZ:
        s="lekarz";
        break;
      case TLEN_PUBDIR_JOB_INNY:
        s="inny";
        break;
      default:
        s="";
    }
    if(s)
    {
      s=utf(s);
      gtk_entry_set_text(GTK_ENTRY(widget),s);
      g_free(s);
    }
    else
      gtk_entry_set_text(GTK_ENTRY(widget), "");
    widget=lookup_widget(window_card, "entry_voice");
    if(item->voice == TLEN_PUBDIR_VOICE_DISABLED)
      gtk_entry_set_text(GTK_ENTRY(widget),"nie");
    else
      gtk_entry_set_text(GTK_ENTRY(widget),"tak");
    widget=lookup_widget(window_card, "entry_plans");
    switch(item->plans)
    {
      case TLEN_PUBDIR_WANT_NONE:
        s="";
        break;
      case TLEN_PUBDIR_WANT_CINEMA:
        s="kino";
        break;
      default:
        s="";
    }
    if(s)
    {
      s=utf(s);
      gtk_entry_set_text(GTK_ENTRY(widget),s);
      g_free(s);
    }
    else
      gtk_entry_set_text(GTK_ENTRY(widget), "");
  }
}

void window_card_button_import_clicked ()
{
  if (!tlen_pubdir_get (profile->tc))
    info ("Polecenie nie moe by zrealizowane");
  else
    window_card_show_thobber ();
}

void window_card_button_export_clicked ()
{
  TlenPubdirItem *pubdir;
  GtkWidget *widget;
  gchar *s;


  pubdir = tlen_pubdir_item_new ();
  widget = lookup_widget(window_card, "entry_surname");
  s = (gchar*) fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(tlen_strlen(s)>0)
    pubdir->firstname = s;
  widget = lookup_widget(window_card,"entry_name");
  s = (gchar*) fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(tlen_strlen(s)>0)
    pubdir->lastname = s;
  widget = lookup_widget(window_card, "entry_nick");
  s = (gchar*) fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(tlen_strlen(s)>0)
    pubdir->nick = s;
  widget = lookup_widget(window_card, "entry_gender");
  s = (gchar*) fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(!tlen_strcmp(s,"kobieta"))
    pubdir->gender = TLEN_PUBDIR_GENDER_FEMALE;
  else if(!tlen_strcmp(s,"mczyzna"))
    pubdir->gender = TLEN_PUBDIR_GENDER_MALE;
  else
    pubdir->gender = TLEN_PUBDIR_GENDER_NONE;
  g_free(s);
  widget = lookup_widget(window_card, "entry_city");
  s = (gchar*) fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(tlen_strlen(s)>0)
    pubdir->city = s;
  widget = lookup_widget(window_card, "entry_email");
  s = (gchar*) fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(tlen_strlen(s)>0)
    pubdir->email = s;
  widget = lookup_widget(window_card, "spinbutton_year");
  pubdir->birthyear = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(widget));
  widget = lookup_widget(window_card,"entry_status");
  s = (gchar*) fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(!tlen_strcmp(s,"nie"))
    pubdir->visible = TLEN_PUBDIR_VISIBLE_NO;
  else
    pubdir->visible = TLEN_PUBDIR_VISIBLE_YES;
  widget = lookup_widget(window_card, "entry_look");
  g_free(s);
  s = (gchar*) fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(!tlen_strcmp(s,""))
    pubdir->look_for = TLEN_PUBDIR_LOOK_NONE;
  else if(!tlen_strcmp(s,"rozmowa"))
    pubdir->look_for = TLEN_PUBDIR_LOOK_TALK;
  else if(!tlen_strcmp(s,"przyja"))
    pubdir->look_for = TLEN_PUBDIR_LOOK_FRIEND;
  else if(!tlen_strcmp(s,"romans"))
    pubdir->look_for = TLEN_PUBDIR_LOOK_FLIRT;
  else if(!tlen_strcmp(s,"mio"))
    pubdir->look_for = TLEN_PUBDIR_LOOK_LOVE;
  widget = lookup_widget(window_card, "entry_school");
  g_free(s);
  s = (gchar*) fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(tlen_strlen(s)>0)
    pubdir->school = s;
  widget = lookup_widget(window_card, "entry_job");
  s = (gchar*) fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(!tlen_strcmp(s,""))
    pubdir->job = TLEN_PUBDIR_JOB_NONE;
  else if(!tlen_strcmp(s,"ucze"))
    pubdir->job = TLEN_PUBDIR_JOB_UCZEN;
  else if(!tlen_strcmp(s,"student"))
    pubdir->job = TLEN_PUBDIR_JOB_STUDENT;
  else if(!tlen_strcmp(s,"rolnik"))
    pubdir->job = TLEN_PUBDIR_JOB_ROLNIK;
  else if(!tlen_strcmp(s,"meneder"))
    pubdir->job = TLEN_PUBDIR_JOB_MENEDZER;
  else if(!tlen_strcmp(s,"specjalista"))
    pubdir->job = TLEN_PUBDIR_JOB_SPEC_WOL;
  else if(!tlen_strcmp(s,"urzdnik"))
    pubdir->job = TLEN_PUBDIR_JOB_UUA;
  else if(!tlen_strcmp(s,"emeryt,rencista"))
    pubdir->job = TLEN_PUBDIR_JOB_EMERYT;
  else if(!tlen_strcmp(s,"gospodyni"))
    pubdir->job = TLEN_PUBDIR_JOB_GOSPODYNI;
  else if(!tlen_strcmp(s,"nauczyciel"))
    pubdir->job = TLEN_PUBDIR_JOB_NAUCZYCIEL;
  else if(!tlen_strcmp(s,"lekarz"))
    pubdir->job = TLEN_PUBDIR_JOB_LEKARZ;
  else if(!tlen_strcmp(s,"inny"))
    pubdir->job = TLEN_PUBDIR_JOB_INNY;
  else if(!tlen_strcmp(s,"bezrobotny"))
    pubdir->job = TLEN_PUBDIR_JOB_BEZROBOTNY;
  widget = lookup_widget(window_card, "entry_voice");
  g_free(s);
  s = (gchar*) fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(!tlen_strcmp(s,"nie"))
    pubdir->voice = TLEN_PUBDIR_VOICE_DISABLED;
  else
    pubdir->voice = TLEN_PUBDIR_VOICE_ENABLED;
  widget = lookup_widget(window_card, "entry_plans");
  g_free(s);
  s = (gchar*) fromutf(gtk_entry_get_text(GTK_ENTRY(widget)));
  if(!tlen_strcmp(s,""))
    pubdir->plans = TLEN_PUBDIR_WANT_NONE;
  else if(!tlen_strcmp(s,"kino"))
    pubdir->plans = TLEN_PUBDIR_WANT_CINEMA;
  g_free(s);

  if (!tlen_pubdir_set(profile->tc, pubdir))
    info ("Polecenie nie moe by zrealizowane");
  else
    window_card_show_thobber();
  tlen_pubdir_item_free (pubdir);
}

void window_card_close (void)
{
  if (window_card)
  {
    gtk_widget_destroy (window_card);
    window_card = NULL;
  }
}

static
void search_window_pixbuf(GtkTreeViewColumn *tree_column,
                          GtkCellRenderer   *cell,
                          GtkTreeModel      *model,
                          GtkTreeIter       *iter,
                          gpointer           data)
{
  guint status;

  gtk_tree_model_get (model, iter,
                      0, &status,
                      -1);
  g_object_set (GTK_CELL_RENDERER (cell),
                "pixbuf",
                gtk_image_get_pixbuf(GTK_IMAGE(icons_tlen_get(status))),
                NULL);
}

static
void search_window_text (GtkTreeViewColumn *tree_column,
                         GtkCellRenderer   *cell,
                         GtkTreeModel      *model,
                         GtkTreeIter       *iter,
                         gpointer           data)
{
  gchar *jid;

  gtk_tree_model_get (model, iter,
                      1, &jid,
                      -1);
  if(list_user_item_get(jid))
    g_object_set (GTK_CELL_RENDERER (cell),
                  "font", "bold",
                  NULL);
  else
    g_object_set (GTK_CELL_RENDERER (cell),
                  "font", "normal",
                  NULL);
  g_object_set (GTK_CELL_RENDERER (cell),
                "text", jid,
                NULL);
}

